      SUBROUTINE UEL(RHS,AMATRX,SVARS,ENERGY,                     
     1     NDOFEL,NRHS,NSVARS,PROPS,NPROPS,COORDS,
     2     MCRD,NNODE,U,DU,V,A,JTYPE,TIME,DTIME,
     3     KSTEP,KINC,JELEM,PARAMS,NDLOAD,JDLTYP,
     4     ADLMAG,PREDEF,NPREDF,LFLAGS,MLVARX,
     5     DDLMAG,MDLOAD,PNEWDT,JPROPS,NJPROP,
     6     PERIOD)
C     
      INCLUDE 'ABA_PARAM.INC'
      PARAMETER ( k=1.0)
C
      DIMENSION RHS(MLVARX,*),
     1     AMATRX(NDOFEL,NDOFEL),
     2     SVARS(NSVARS),ENERGY(8),PROPS(*),
     3     COORDS(MCRD,NNODE),U(NDOFEL),
     4     DU(MLVARX,*),V(NDOFEL),A(NDOFEL),
     5     TIME(2),PARAMS(3),JDLTYP(MDLOAD,*),
     6     ADLMAG(MDLOAD,*),DDLMAG(MDLOAD,*),
     7     PREDEF(2,NPREDF,NNODE),LFLAGS(*),
     8     JPROPS(*)
      DIMENSION SRESID(6)
C
C     USER ELEMENT TO SIMULATE BENDING-INDUCED
C     TORSIONAL STRESS 
C     
C     PROPERTIES:
C     AREA OF CROSS SECTION: A
C     MOMENT OF INERTIA-Y: Iy
C     MOMENT OF INERTIA-Z: Iz
C     BENING STIFFNESS-Y: EI_y
C     BENING STIFFNESS-Z: EI_z
C     AXIAL STIFFNESS: EA
C     GA
C     TORSIONAL CONSTANT: J
C     LENGTH OF ELEMENT: L     
C
      Di=PROPS(1)-2*PROPS(2)
      A=0.25*PROPS(5)*(Di**2)
      Iy=(PROPS(5)/64)*(PROPS(1)**4-Di**4)
      Iz=(PROPS(5)/64)*(PROPS(1)**4-Di**4)
      EI_y=PROPS(3)*Iy
      EI_z=PROPS(3)*Iz
      G=PROPS(3)/(2*(1+PROPS(4)))
      J=2*(PROPS(5)/64)*(PROPS(1)**4-Di**4)
      L=sqrt((COORDS(1,2)-COORDS(1,1))**2  
     *  +(COORDS(2,2)-COORDS(2,1))**2 
     *  +(COORDS(3,2)-COORDS(3,1))**2)
      DEN1=(12*EI_y-k*G*A*L**2)**2
C     DEN2=(12*EI_z-k*G*A*L**2)**2
C     NUME1=k*G*A*EI_y*(12*EI_y+k*G*A*L**2)
C     NUME2=k*G*A*EI_z*(12*EI_z+k*G*A*L**2)
C     DEN1=1.0
      DEN2=1.0
      NUME1=1.0
      NUME2=1.0
C
      DO K1=1, NDOFEL  
        SRESID(K1)=0                   
        DO KRHS = 1, NRHS
          RHS(K1,KRHS)=0
        END DO
        DO K2=1, NDOFEL                                           
          AMATRX(K2,K1)=0                                      
        END DO                                                    
      END DO                                                      
                                                                  
      do k1=1, nsvars                                             
         svars(k1)=0                                           
      end do                                                      
C                                                                 
      IF (LFLAGS(3).EQ.1) THEN                                    
C       Normal incrementation                                     
        IF (LFLAGS(1).EQ.1 .OR. LFLAGS(1).EQ.2) THEN              
C        *STATIC                                                  
          AMATRX(1,1)=EA/L                                        
          AMATRX(7,7)=AMATRX(1,1)                                 
          AMATRX(1,7)=-AMATRX(1,1)                                
          AMATRX(2,2)=12*NUME1/(L*DEN1)                           
          AMATRX(2,8)=-AMATRX(2,2)                                
          AMATRX(2,6)=6*NUME1/DEN1                                
          AMATRX(2,12)=AMATRX(2,6)                                
          AMATRX(3,3)=12*NUME2/(L*DEN2)                           
          AMATRX(3,9)=AMATRX(3,3)                                 
          AMATRX(3,5)=-6*NUME2/DEN2                               
          AMATRX(3,11)=AMATRX(3,5)                                
          AMATRX(4,4)=G*(Iy+Iz)/L                                 
          AMATRX(7,7)=AMATRX(4,4)                                 
          AMATRX(4,10)=-AMATRX(4,4)                               
          AMATRX(5,5)=4*EI_z*(((k*G*A)**2)*(L**4)+3*k*G*A*(L**2)*EI_z+36*(EI_z**2))/(L*DEN2)
          AMATRX(5,9)=6*NUME2/DEN2
          AMATRX(5,11)=-2*EI_z
     *    *(72*EI_z**2-((k*G*A)**2)*(L**4)
     *    -30*k*G*A*(L**2)*EI_z)/(L*DEN2)
          AMATRX(6,6)=4*EI_y
     *    *(((k*G*A)**2)*(L**4)+3*k*G*A*(L**2)
     *    *EI_y+36*(EI_y**2))/(L*DEN1)
          AMATRX(6,8)=-6*NUME1/DNE1
          AMATRX(6,12)=-2*EI_y
     *    *(72*EI_y**2-((k*G*A)**2)*(L**4)
     *    -30*k*G*A*(L**2)*EI_y)/(L*DEN1)
          AMATRX(8,8)=12*NUME1/(L*DEN1)
          AMATRX(8,12)=-6*NUME1/DEN1
          AMATRX(9,9)=12*NUME2/(L*DEN2)
          AMATRX(9,11)=6*NUME2/DEN2
          AMATRX(11,11)=4*EI_z
     *    *(((k*G*A)**2)*(L**4)+3*k*G*A*(L**2)
     *    *EI_z+36*(EI_z**2))/(L*DEN2)
          AMATRX(12,12)=4*EI_y
     *    *(((k*G*A)**2)*(L**4)+3*k*G*A*(L**2)
     *    *EI_y+36*(EI_y**2))/(L*DEN1)
C
          IF (LFLAGS(4).EQ.0) THEN
            RHS(1,1)=1
            RHS(2,1)=1
            RHS(3,1)=1
            RHS(4,1)=1
            RHS(5,1)=1
            RHS(6,1)=1
            RHS(7,1)=1
            RHS(8,1)=1
            RHS(9,1)=1
            RHS(10,1)=1
            RHS(11,1)=1
            RHS(12,1)=1
          END IF
        END IF
      END IF 
      RETURN
      END         